Loading...
Searching...
No Matches
juce::FileBrowserComponent Class Reference

## Detailed Description

A component for browsing and selecting a file or directory to open or save.

This contains a FileListComponent and adds various boxes and controls for navigating and selecting a file. It can work in different modes so that it can be used for loading or saving a file, or for choosing a directory.

See also
  FileChooserDialogBox, FileChooser, FileListComponent

The documentation for this class was generated from the following file:

- juce_gui_basics/filebrowser/juce_FileBrowserComponent.h

Inheritance diagram for juce::FileBrowserComponent:

## Classes

struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide various file-browser layout and drawing methods. More...

## Public Types

enum | FileChooserFlags { openMode = 1 , saveMode = 2 , canSelectFiles = 4 , canSelectDirectories = 8 , canSelectMultipleItems = 16 , useTreeView = 32 , filenameBoxIsReadOnly = 64 , warnAboutOverwriting = 128 , doNotClearFileNameOnRootChange = 256 }
| Various options for the browser. More...
enum | ColourIds { currentPathBoxBackgroundColourId = 0x1000640 , currentPathBoxTextColourId = 0x1000641 , currentPathBoxArrowColourId = 0x1000642 , filenameBoxBackgroundColourId = 0x1000643 , filenameBoxTextColourId = 0x1000644 }
| A set of colour IDs to use to change the colour of various aspects of the FileBrowserComponent. More...
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| FileBrowserComponent (int flags, const File &initialFileOrDirectory, const FileFilter *fileFilter, FilePreviewComponent *previewComp)
| Creates a FileBrowserComponent.
| ~FileBrowserComponent () override
| Destructor.
int | getNumSelectedFiles () const noexcept
| Returns the number of files that the user has got selected.
File | getSelectedFile (int index) const noexcept
| Returns one of the files that the user has chosen.
void | deselectAllFiles ()
| Deselects any files that are currently selected.
bool | currentFileIsValid () const
| Returns true if the currently selected file(s) are usable.
File | getHighlightedFile () const noexcept
| This returns the last item in the view that the user has highlighted.
const File & | getRoot () const
| Returns the directory whose contents are currently being shown in the listbox.
void | setRoot (const File &newRootDirectory)
| Changes the directory that's being shown in the listbox.
void | setFileName (const String &newName)
| Changes the name that is currently shown in the filename box.
void | goUp ()
| Equivalent to pressing the "up" button to browse the parent directory.
void | refresh ()
| Refreshes the directory that's currently being listed.
void | setFileFilter (const FileFilter *newFileFilter)
| Changes the filter that's being used to sift the files.
virtual String | getActionVerb () const
| Returns a verb to describe what should happen when the file is accepted.
bool | isSaveMode () const noexcept
| Returns true if the saveMode flag was set when this component was created.
void | setFilenameBoxLabel (const String &name)
| Sets the label that will be displayed next to the filename entry box.
void | addListener (FileBrowserListener *listener)
| Adds a listener to be told when the user selects and clicks on files.
void | removeListener (FileBrowserListener *listener)
| Removes a listener.
void | resized () override
| Called when this component's size has been changed.
void | lookAndFeelChanged () override
| Called to let the component react to a change in the look-and-feel setting.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
void | selectionChanged () override
| Callback when the user selects a different file in the browser.
void | fileClicked (const File &, const MouseEvent &) override
| Callback when the user clicks on a file in the browser.
void | fileDoubleClicked (const File &) override
| Callback when the user double-clicks on a file in the browser.
void | browserRootChanged (const File &) override
| Callback when the browser's root folder changes.
bool | isFileSuitable (const File &) const override
| Should return true if this file is suitable for inclusion in whatever context the object is being used.
bool | isDirectorySuitable (const File &) const override
| Should return true if this directory is suitable for inclusion in whatever context the object is being used.
FilePreviewComponent * | getPreviewComponent () const noexcept
DirectoryContentsDisplayComponent * | getDisplayComponent () const noexcept
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paint (Graphics &g)
| Components can override this method to draw their content.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.

## Static Public Member Functions

static void | getDefaultRoots (StringArray &rootNames, StringArray &rootPaths)
| Returns a platform-specific list of names and paths for some suggested places the user might want to use as root folders.
Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Protected Member Functions

virtual void | getRoots (StringArray &rootNames, StringArray &rootPaths)
| Returns a list of names and paths for the default places the user might want to look.
void | resetRecentPaths ()
| Updates the items in the dropdown list of recent paths with the values from getRoots().

## Member Enums

## FileChooserFlags

enum juce::FileBrowserComponent::FileChooserFlags

Various options for the browser.

A combination of these is passed into the FileBrowserComponent constructor.

Enumerator
openMode | specifies that the component should allow the user to choose an existing file with the intention of opening it.
saveMode | specifies that the component should allow the user to specify the name of a file that will be used to save something.
canSelectFiles | specifies that the user can select files (can be used in conjunction with canSelectDirectories).
canSelectDirectories | specifies that the user can select directories (can be used in conjunction with canSelectFiles).
canSelectMultipleItems | specifies that the user can select multiple items.
useTreeView | specifies that a tree-view should be shown instead of a file list.
filenameBoxIsReadOnly | specifies that the user can't type directly into the filename box.
warnAboutOverwriting | specifies that the dialog should warn about overwriting existing files (if possible).
doNotClearFileNameOnRootChange | specifies that the file name should not be cleared upon root change.

## ColourIds

enum juce::FileBrowserComponent::ColourIds

A set of colour IDs to use to change the colour of various aspects of the FileBrowserComponent.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
currentPathBoxBackgroundColourId | The colour to use to fill the background of the current path ComboBox.
currentPathBoxTextColourId | The colour to use for the text of the current path ComboBox.
currentPathBoxArrowColourId | The colour to use to draw the arrow of the current path ComboBox.
filenameBoxBackgroundColourId | The colour to use to fill the background of the filename TextEditor.
filenameBoxTextColourId | The colour to use for the text of the filename TextEditor.

## Constructors and Destructors

## FileBrowserComponent()

juce::FileBrowserComponent::FileBrowserComponent | ( | int | flags,
|  | const File & | initialFileOrDirectory,
|  | const FileFilter * | fileFilter,
|  | FilePreviewComponent * | previewComp )

Creates a FileBrowserComponent.

Parameters

  flags | A combination of flags from the FileChooserFlags enumeration, used to specify the component's behaviour. The flags must contain either openMode or saveMode, and canSelectFiles and/or canSelectDirectories.
  initialFileOrDirectory | The file or directory that should be selected when the component begins. If this is File(), a default directory will be chosen.
  fileFilter | an optional filter to use to determine which files are shown. If this is nullptr then all files are displayed. Note that a pointer is kept internally to this object, so make sure that it is not deleted before the FileBrowserComponent object is deleted.
  previewComp | an optional preview component that will be used to show previews of files that the user selects

References juce::FileFilter::FileFilter().

Referenced by juce::FileBrowserComponent::LookAndFeelMethods::layoutFileBrowserComponent(), and resetRecentPaths().

## ~FileBrowserComponent()

juce::FileBrowserComponent::~FileBrowserComponent | ( |  | ) |

override

Destructor.

## Member Functions

## getNumSelectedFiles()

int juce::FileBrowserComponent::getNumSelectedFiles | ( |  | ) | const

noexcept

Returns the number of files that the user has got selected.

If multiple select isn't active, this will only be 0 or 1. To get the complete list of files they've chosen, pass an index to getCurrentFile().

## getSelectedFile()

File juce::FileBrowserComponent::getSelectedFile | ( | int | index | ) | const

noexcept

Returns one of the files that the user has chosen.

If the box has multi-select enabled, the index lets you specify which of the files to get - see getNumSelectedFiles() to find out how many files were chosen.

See also
  getHighlightedFile

References getSelectedFile().

Referenced by getSelectedFile().

## deselectAllFiles()

void juce::FileBrowserComponent::deselectAllFiles | ( |  | ) |

Deselects any files that are currently selected.

References deselectAllFiles().

Referenced by deselectAllFiles().

## currentFileIsValid()

bool juce::FileBrowserComponent::currentFileIsValid | ( |  | ) | const

Returns true if the currently selected file(s) are usable.

This can be used to decide whether the user can press "ok" for the current file. What it does depends on the mode, so for example in an "open" mode, this only returns true if a file has been selected and if it exists. In a "save" mode, a non-existent file would also be valid.

References currentFileIsValid().

Referenced by currentFileIsValid().

## getHighlightedFile()

File juce::FileBrowserComponent::getHighlightedFile | ( |  | ) | const

noexcept

This returns the last item in the view that the user has highlighted.

This may be different from getCurrentFile(), which returns the value that is shown in the filename box, and if there are multiple selections, this will only return one of them.

See also
  getSelectedFile

References getHighlightedFile().

Referenced by getHighlightedFile().

## getRoot()

const File & juce::FileBrowserComponent::getRoot | ( |  | ) | const

Returns the directory whose contents are currently being shown in the listbox.

References getRoot().

Referenced by getRoot().

## setRoot()

void juce::FileBrowserComponent::setRoot | ( | const File & | newRootDirectory | ) |

Changes the directory that's being shown in the listbox.

References setRoot().

Referenced by setRoot().

## setFileName()

void juce::FileBrowserComponent::setFileName | ( | const String & | newName | ) |

Changes the name that is currently shown in the filename box.

References setFileName().

Referenced by setFileName().

## goUp()

void juce::FileBrowserComponent::goUp | ( |  | ) |

Equivalent to pressing the "up" button to browse the parent directory.

References goUp().

Referenced by goUp().

## refresh()

void juce::FileBrowserComponent::refresh | ( |  | ) |

Refreshes the directory that's currently being listed.

References refresh().

Referenced by refresh().

## setFileFilter()

void juce::FileBrowserComponent::setFileFilter | ( | const FileFilter * | newFileFilter | ) |

Changes the filter that's being used to sift the files.

References juce::FileFilter::FileFilter(), and setFileFilter().

Referenced by setFileFilter().

## getActionVerb()

virtual String juce::FileBrowserComponent::getActionVerb | ( |  | ) | const

virtual

Returns a verb to describe what should happen when the file is accepted.

E.g. if browsing in "load file" mode, this will be "Open", if in "save file" mode, it'll be "Save", etc.

References getActionVerb().

Referenced by getActionVerb().

## isSaveMode()

bool juce::FileBrowserComponent::isSaveMode | ( |  | ) | const

noexcept

Returns true if the saveMode flag was set when this component was created.

References isSaveMode().

Referenced by isSaveMode().

## setFilenameBoxLabel()

void juce::FileBrowserComponent::setFilenameBoxLabel | ( | const String & | name | ) |

Sets the label that will be displayed next to the filename entry box.

By default this is just "file", but you might want to change it to something more appropriate for your app.

References name, and setFilenameBoxLabel().

Referenced by setFilenameBoxLabel().

## addListener()

void juce::FileBrowserComponent::addListener | ( | FileBrowserListener * | listener | ) |

Adds a listener to be told when the user selects and clicks on files.

See also
  removeListener

References addListener().

Referenced by addListener().

## removeListener()

void juce::FileBrowserComponent::removeListener | ( | FileBrowserListener * | listener | ) |

Removes a listener.

See also
  addListener

References removeListener().

Referenced by removeListener().

## getDefaultRoots()

void juce::FileBrowserComponent::getDefaultRoots | ( | StringArray & | rootNames,
|  | StringArray & | rootPaths )

static

Returns a platform-specific list of names and paths for some suggested places the user might want to use as root folders.

The list returned contains empty strings to indicate section breaks.

See also
  getRoots()

References getDefaultRoots().

Referenced by getDefaultRoots().

## resized()

void juce::FileBrowserComponent::resized | ( |  | ) |

override virtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from juce::Component.

## lookAndFeelChanged()

void juce::FileBrowserComponent::lookAndFeelChanged | ( |  | ) |

override virtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this method, repaint(), and colourChanged() are called on the original component and all its children recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented from juce::Component.

## keyPressed()

bool juce::FileBrowserComponent::keyPressed | ( | const KeyPress & | key | ) |

override virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## selectionChanged()

void juce::FileBrowserComponent::selectionChanged | ( |  | ) |

override virtual

Callback when the user selects a different file in the browser.

Implements juce::FileBrowserListener.

## fileClicked()

void juce::FileBrowserComponent::fileClicked | ( | const File & | file,
|  | const MouseEvent & | e )

override virtual

Callback when the user clicks on a file in the browser.

Implements juce::FileBrowserListener.

## fileDoubleClicked()

void juce::FileBrowserComponent::fileDoubleClicked | ( | const File & | file | ) |

override virtual

Callback when the user double-clicks on a file in the browser.

Implements juce::FileBrowserListener.

## browserRootChanged()

void juce::FileBrowserComponent::browserRootChanged | ( | const File & | newRoot | ) |

override virtual

Callback when the browser's root folder changes.

Implements juce::FileBrowserListener.

## isFileSuitable()

bool juce::FileBrowserComponent::isFileSuitable | ( | const File & | file | ) | const

override virtual

Should return true if this file is suitable for inclusion in whatever context the object is being used.

Implements juce::FileFilter.

## isDirectorySuitable()

bool juce::FileBrowserComponent::isDirectorySuitable | ( | const File & | file | ) | const

override virtual

Should return true if this directory is suitable for inclusion in whatever context the object is being used.

Implements juce::FileFilter.

## getPreviewComponent()

FilePreviewComponent * juce::FileBrowserComponent::getPreviewComponent | ( |  | ) | const

noexcept

## getDisplayComponent()

DirectoryContentsDisplayComponent * juce::FileBrowserComponent::getDisplayComponent | ( |  | ) | const

noexcept

References getDisplayComponent().

Referenced by getDisplayComponent().

## createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > juce::FileBrowserComponent::createAccessibilityHandler | ( |  | ) |

override virtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from juce::Component.

References createAccessibilityHandler().

Referenced by createAccessibilityHandler().

## getRoots()

virtual void juce::FileBrowserComponent::getRoots | ( | StringArray & | rootNames,
|  | StringArray & | rootPaths )

protected virtual

Returns a list of names and paths for the default places the user might want to look.

By default this just calls getDefaultRoots(), but you may want to override it to return a custom list.

References getRoots().

Referenced by getRoots().

## resetRecentPaths()

void juce::FileBrowserComponent::resetRecentPaths | ( |  | ) |

protected

Updates the items in the dropdown list of recent paths with the values from getRoots().

References FileBrowserComponent(), juce::FileFilter::FileFilter(), JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR, and resetRecentPaths().

Referenced by resetRecentPaths().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited